
#include "gertbot.h"
#include <QApplication>

gb_motor_type gb_motor[4][4] = 
{
  {  // board 0
    { // motor 0 
      MOT_MODE_OFF,// byte mode;
      0,           // byte endmode;
      MOT_PWR_OFF, // byte move;
      0,           // byte ramp_up;
      0,           // byte ramp_down;
      0,           // byte ramp_halt;
      0,           // byte short_hot_stop;
      0,           // uint32_t flags;
      0,           // uint32_t frequency;
      0,           // uint32_t duty_cycle;
      0,           // int32_t  steps;
      0,           // int32_t  remain;
      0,           // int32_t  missed;
      // quad 
      { 0,         // bool on;
        0,0,       // bool max_stop,min_stop;
        0,         // bool slow_on;
        0,         // int  position;
        0,         // uint32_t duty_cycle;
        0,0,       // int  max_pos,min_pos;
        0,         // int  goto_pos;
        0          // int  slow_dist;    
      }  
    },
    { // motor 1 
      MOT_MODE_OFF,// byte mode;
      0,           // byte endmode;
      MOT_PWR_OFF, // byte move;
      0,           // byte ramp_up;
      0,           // byte ramp_down;
      0,           // byte ramp_halt;
      0,           // byte short_hot_stop;
      0,           // uint32_t flags;
      0,           // uint32_t frequency;
      0,           // uint32_t duty_cycle;
      0,           // int32_t  steps;
      0,           // int32_t  remain;
      0,           // int32_t  missed;
      // quad 
      { 0,         // bool on;
        0,0,       // bool max_stop,min_stop;
        0,         // bool slow_on;
        0,         // int  position;
        0,         // uint32_t duty_cycle;
        0,0,       // int  max_pos,min_pos;
        0,         // int  goto_pos;
        0          // int  slow_dist;    
      }  
    },
    { // motor 2 
      MOT_MODE_OFF,// byte mode;
      0,           // byte endmode;
      MOT_PWR_OFF, // byte move;
      0,           // byte ramp_up;
      0,           // byte ramp_down;
      0,           // byte ramp_halt;
      0,           // byte short_hot_stop;
      0,           // uint32_t flags;
      0,           // uint32_t frequency;
      0,           // uint32_t duty_cycle;
      0,           // int32_t  steps;
      0,           // int32_t  remain;
      0,           // int32_t  missed;
      // quad 
      { 0,         // bool on;
        0,0,       // bool max_stop,min_stop;
        0,         // bool slow_on;
        0,         // int  position;
        0,         // uint32_t duty_cycle;
        0,0,       // int  max_pos,min_pos;
        0,         // int  goto_pos;
        0          // int  slow_dist;    
      }  
    },
    { // motor 3 
      MOT_MODE_OFF,// byte mode;
      0,           // byte endmode;
      MOT_PWR_OFF, // byte move;
      0,           // byte ramp_up;
      0,           // byte ramp_down;
      0,           // byte ramp_halt;
      0,           // byte short_hot_stop;
      0,           // uint32_t flags;
      0,           // uint32_t frequency;
      0,           // uint32_t duty_cycle;
      0,           // int32_t  steps;
      0,           // int32_t  remain;
      0,           // int32_t  missed;
      // quad 
      { 0,         // bool on;
        0,0,       // bool max_stop,min_stop;
        0,         // bool slow_on;
        0,         // int  position;
        0,         // uint32_t duty_cycle;
        0,0,       // int  max_pos,min_pos;
        0,         // int  goto_pos;
        0          // int  slow_dist;    
      }  
    },
  }, // board 0
  
  {  ////// board 1
    { // motor 0 
      MOT_MODE_OFF,// byte mode;
      0,           // byte endmode;
      MOT_PWR_OFF, // byte move;
      0,           // byte ramp_up;
      0,           // byte ramp_down;
      0,           // byte ramp_halt;
      0,           // byte short_hot_stop;
      0,           // uint32_t flags;
      0,           // uint32_t frequency;
      0,           // uint32_t duty_cycle;
      0,           // int32_t  steps;
      0,           // int32_t  remain;
      0,           // int32_t  missed;
      // quad 
      { 0,         // bool on;
        0,0,       // bool max_stop,min_stop;
        0,         // bool slow_on;
        0,         // int  position;
        0,         // uint32_t duty_cycle;
        0,0,       // int  max_pos,min_pos;
        0,         // int  goto_pos;
        0          // int  slow_dist;    
      }  
    },
    { // motor 1 
      MOT_MODE_OFF,// byte mode;
      0,           // byte endmode;
      MOT_PWR_OFF, // byte move;
      0,           // byte ramp_up;
      0,           // byte ramp_down;
      0,           // byte ramp_halt;
      0,           // byte short_hot_stop;
      0,           // uint32_t flags;
      0,           // uint32_t frequency;
      0,           // uint32_t duty_cycle;
      0,           // int32_t  steps;
      0,           // int32_t  remain;
      0,           // int32_t  missed;
      // quad 
      { 0,         // bool on;
        0,0,       // bool max_stop,min_stop;
        0,         // bool slow_on;
        0,         // int  position;
        0,         // uint32_t duty_cycle;
        0,0,       // int  max_pos,min_pos;
        0,         // int  goto_pos;
        0          // int  slow_dist;    
      }  
    },
    { // motor 2 
      MOT_MODE_OFF,// byte mode;
      0,           // byte endmode;
      MOT_PWR_OFF, // byte move;
      0,           // byte ramp_up;
      0,           // byte ramp_down;
      0,           // byte ramp_halt;
      0,           // byte short_hot_stop;
      0,           // uint32_t flags;
      0,           // uint32_t frequency;
      0,           // uint32_t duty_cycle;
      0,           // int32_t  steps;
      0,           // int32_t  remain;
      0,           // int32_t  missed;
      // quad 
      { 0,         // bool on;
        0,0,       // bool max_stop,min_stop;
        0,         // bool slow_on;
        0,         // int  position;
        0,         // uint32_t duty_cycle;
        0,0,       // int  max_pos,min_pos;
        0,         // int  goto_pos;
        0          // int  slow_dist;    
      }  
    },
    { // motor 3 
      MOT_MODE_OFF,// byte mode;
      0,           // byte endmode;
      MOT_PWR_OFF, // byte move;
      0,           // byte ramp_up;
      0,           // byte ramp_down;
      0,           // byte ramp_halt;
      0,           // byte short_hot_stop;
      0,           // uint32_t flags;
      0,           // uint32_t frequency;
      0,           // uint32_t duty_cycle;
      0,           // int32_t  steps;
      0,           // int32_t  remain;
      0,           // int32_t  missed;
      // quad 
      { 0,         // bool on;
        0,0,       // bool max_stop,min_stop;
        0,         // bool slow_on;
        0,         // int  position;
        0,         // uint32_t duty_cycle;
        0,0,       // int  max_pos,min_pos;
        0,         // int  goto_pos;
        0          // int  slow_dist;    
      }  
    },
  }, // board 1
  
  {  ////// board 2
    { // motor 0 
      MOT_MODE_OFF,// byte mode;
      0,           // byte endmode;
      MOT_PWR_OFF, // byte move;
      0,           // byte ramp_up;
      0,           // byte ramp_down;
      0,           // byte ramp_halt;
      0,           // byte short_hot_stop;
      0,           // uint32_t flags;
      0,           // uint32_t frequency;
      0,           // uint32_t duty_cycle;
      0,           // int32_t  steps;
      0,           // int32_t  remain;
      0,           // int32_t  missed;
      // quad 
      { 0,         // bool on;
        0,0,       // bool max_stop,min_stop;
        0,         // bool slow_on;
        0,         // int  position;
        0,         // uint32_t duty_cycle;
        0,0,       // int  max_pos,min_pos;
        0,         // int  goto_pos;
        0          // int  slow_dist;    
      }  
    },
    { // motor 1 
      MOT_MODE_OFF,// byte mode;
      0,           // byte endmode;
      MOT_PWR_OFF, // byte move;
      0,           // byte ramp_up;
      0,           // byte ramp_down;
      0,           // byte ramp_halt;
      0,           // byte short_hot_stop;
      0,           // uint32_t flags;
      0,           // uint32_t frequency;
      0,           // uint32_t duty_cycle;
      0,           // int32_t  steps;
      0,           // int32_t  remain;
      0,           // int32_t  missed;
      // quad 
      { 0,         // bool on;
        0,0,       // bool max_stop,min_stop;
        0,         // bool slow_on;
        0,         // int  position;
        0,         // uint32_t duty_cycle;
        0,0,       // int  max_pos,min_pos;
        0,         // int  goto_pos;
        0          // int  slow_dist;    
      }  
    },
    { // motor 2 
      MOT_MODE_OFF,// byte mode;
      0,           // byte endmode;
      MOT_PWR_OFF, // byte move;
      0,           // byte ramp_up;
      0,           // byte ramp_down;
      0,           // byte ramp_halt;
      0,           // byte short_hot_stop;
      0,           // uint32_t flags;
      0,           // uint32_t frequency;
      0,           // uint32_t duty_cycle;
      0,           // int32_t  steps;
      0,           // int32_t  remain;
      0,           // int32_t  missed;
      // quad 
      { 0,         // bool on;
        0,0,       // bool max_stop,min_stop;
        0,         // bool slow_on;
        0,         // int  position;
        0,         // uint32_t duty_cycle;
        0,0,       // int  max_pos,min_pos;
        0,         // int  goto_pos;
        0          // int  slow_dist;    
      }  
    },
    { // motor 3 
      MOT_MODE_OFF,// byte mode;
      0,           // byte endmode;
      MOT_PWR_OFF, // byte move;
      0,           // byte ramp_up;
      0,           // byte ramp_down;
      0,           // byte ramp_halt;
      0,           // byte short_hot_stop;
      0,           // uint32_t flags;
      0,           // uint32_t frequency;
      0,           // uint32_t duty_cycle;
      0,           // int32_t  steps;
      0,           // int32_t  remain;
      0,           // int32_t  missed;
      // quad 
      { 0,         // bool on;
        0,0,       // bool max_stop,min_stop;
        0,         // bool slow_on;
        0,         // int  position;
        0,         // uint32_t duty_cycle;
        0,0,       // int  max_pos,min_pos;
        0,         // int  goto_pos;
        0          // int  slow_dist;    
      }  
    },
  }, // board 2
  
  {  ////// board 3
    { // motor 0 
      MOT_MODE_OFF,// byte mode;
      0,           // byte endmode;
      MOT_PWR_OFF, // byte move;
      0,           // byte ramp_up;
      0,           // byte ramp_down;
      0,           // byte ramp_halt;
      0,           // byte short_hot_stop;
      0,           // uint32_t flags;
      0,           // uint32_t frequency;
      0,           // uint32_t duty_cycle;
      0,           // int32_t  steps;
      0,           // int32_t  remain;
      0,           // int32_t  missed;
      // quad 
      { 0,         // bool on;
        0,0,       // bool max_stop,min_stop;
        0,         // bool slow_on;
        0,         // int  position;
        0,         // uint32_t duty_cycle;
        0,0,       // int  max_pos,min_pos;
        0,         // int  goto_pos;
        0          // int  slow_dist;    
      }  
    },
    { // motor 1 
      MOT_MODE_OFF,// byte mode;
      0,           // byte endmode;
      MOT_PWR_OFF, // byte move;
      0,           // byte ramp_up;
      0,           // byte ramp_down;
      0,           // byte ramp_halt;
      0,           // byte short_hot_stop;
      0,           // uint32_t flags;
      0,           // uint32_t frequency;
      0,           // uint32_t duty_cycle;
      0,           // int32_t  steps;
      0,           // int32_t  remain;
      0,           // int32_t  missed;
      // quad 
      { 0,         // bool on;
        0,0,       // bool max_stop,min_stop;
        0,         // bool slow_on;
        0,         // int  position;
        0,         // uint32_t duty_cycle;
        0,0,       // int  max_pos,min_pos;
        0,         // int  goto_pos;
        0          // int  slow_dist;    
      }  
    },
    { // motor 2 
      MOT_MODE_OFF,// byte mode;
      0,           // byte endmode;
      MOT_PWR_OFF, // byte move;
      0,           // byte ramp_up;
      0,           // byte ramp_down;
      0,           // byte ramp_halt;
      0,           // byte short_hot_stop;
      0,           // uint32_t flags;
      0,           // uint32_t frequency;
      0,           // uint32_t duty_cycle;
      0,           // int32_t  steps;
      0,           // int32_t  remain;
      0,           // int32_t  missed;
      // quad 
      { 0,         // bool on;
        0,0,       // bool max_stop,min_stop;
        0,         // bool slow_on;
        0,         // int  position;
        0,         // uint32_t duty_cycle;
        0,0,       // int  max_pos,min_pos;
        0,         // int  goto_pos;
        0          // int  slow_dist;  
      }    
    },
    { // motor 3 
      MOT_MODE_OFF,// byte mode;
      0,           // byte endmode;
      MOT_PWR_OFF, // byte move;
      0,           // byte ramp_up;
      0,           // byte ramp_down;
      0,           // byte ramp_halt;
      0,           // byte short_hot_stop;
      0,           // uint32_t flags;
      0,           // uint32_t frequency;
      0,           // uint32_t duty_cycle;
      0,           // int32_t  steps;
      0,           // int32_t  remain;
      0,           // int32_t  missed;
      // quad 
      { 0,         // bool on;
        0,0,       // bool max_stop,min_stop;
        0,         // bool slow_on;
        0,         // int  position;
        0,         // uint32_t duty_cycle;
        0,0,       // int  max_pos,min_pos;
        0,         // int  goto_pos;
        0          // int  slow_dist;    
      }  
    },
  }  // board 3
}; // motor[4][4]  

gb_board_type board[4] = 
{ 
  {// Board 0 
   0,         // present
   0,         // version 
   0,         // sync_mode
   0x0F,      // adc_enable
   0x00,      // dac_enable
   0x0000C3FF,// input_ports
   0x00,      // output_ports
   0x00,      // inputs_status
   0x00,      // outputs_status
   0x00,      // OD (open drain)
   {0.0,0.0,0.0,0.0}, // adc[4] last read value
   {0.0,0.0},  // dac[2] Last set value
   0           // attentionmode
  }, 
  {// Board 1
   0,         // present
   0,         // version 
   0,         // sync_mode
   0x0F,      // adc_enable
   0x00,      // dac_enable
   0x0000C3FF,// input_ports
   0x00,      // output_ports
   0x00,      // inputs_status
   0x00,      // outputs_status
   0x00,      // OD (open drain)
   {0.0,0.0,0.0,0.0}, // adc[4] last read value
   {0.0,0.0}, // dac[2] Last set value
   0          // attentionmode
  }, 
  {// Board 2
   0,         // present
   0,         // version 
   0,         // sync_mode
   0x0F,      // adc_enable
   0x00,      // dac_enable
   0x0000C3FF,// input_ports
   0x00,      // output_ports
   0x00,      // inputs_status
   0x00,      // outputs_status
   0x00,      // OD (open drain)
   {0.0,0.0,0.0,0.0}, // adc[4] last read value
   {0.0,0.0}, // dac[2] Last set value
   0          // attentionmode
  }, 
  { // Board 3
   0,         // present
   0,         // version 
   0,         // sync_mode
   0x0F,      // adc_enable
   0x00,      // dac_enable
   0x0000C3FF,// input_ports
   0x00,      // output_ports
   0x00,      // inputs_status
   0x00,      // outputs_status
   0x00,      // OD (open drain)
   {0.0,0.0,0.0,0.0}, // adc[4] last read value
   {0.0,0.0}, // dac[2] Last set value
   0          // attentionmode
  } 
};  // board[4]       

//
// Translate mode pull-down to code to be send
// 
int index_to_mode[8] = 
{ 0x00, // Off
  0x01, // Brushed
  0x02, // DCC
  0x03, // Servo
  0x08, // Step gray Off
  0x09, // Step pulse Off
  0x18, // Step gray On
  0x19, // Step pulse On
};
  

gertbot *gertbot_pnt;
bool uart_opened;
uint32_t available_commports;

unsigned char uart_tx_data[32];

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    gertbot w;
    gertbot_pnt = &w;
    w.show();
    return a.exec();
}
